import { StyleSheet, View, Dimensions, LogBox } from "react-native";
import { Themes } from "./assets/Themes";
import { NavigationContainer } from "@react-navigation/native";
import { createStackNavigator } from "@react-navigation/stack";
import React, { useState } from "react";
const windowWidth = Dimensions.get("window").width;
const windowHeight = Dimensions.get("window").height;

LogBox.ignoreLogs(['Warning: ...']); // Ignore log notification by message
LogBox.ignoreAllLogs()

import Survey1 from "./app/components/SurveyScreens/Survey1";
import Survey2 from "./app/components/SurveyScreens/Survey2";
import Survey3 from "./app/components/SurveyScreens/Survey3";
import Survey4 from "./app/components/SurveyScreens/Survey4";
import HomeScreen from "./app/components/HomeScreen/HomeScreen";
import CompletionScreen from "./app/components/CompletionScreen/CompletionScreen";
import MainFriendScreen from "./app/components/FriendScreens/MainFriendScreen1";
import MailScreen from "./app/components/FriendScreens/MailScreen";
import BunnyStatus from "./app/components/FriendScreens/BunnyStatus";
import MouseStatus from "./app/components/FriendScreens/MouseStatus";
import StatusTemplate from "./app/components/FriendScreens/StatusTemplate";
import PigStatus from "./app/components/FriendScreens/PigStatus";
import FriendGarden from "./app/components/FriendScreens/FriendGarden";
import InviteRequestScreen from "./app/components/FriendScreens/InviteRequest";
import VisitRequestScreen from "./app/components/FriendScreens/VisitRequest";
import Chat from "./app/components/FriendScreens/Chat";
import SignUp from "./app/components/SignUp/SignUp";
import GraphScreen from "./app/components/GraphScreen/GraphScreen"
import Inventory from "./app/components/Inventory/Inventory";

const Stack = createStackNavigator();

export default function App() {
  return (
    <View style={styles.container}>
      <NavigationContainer>
        <Stack.Navigator>
          <Stack.Screen
            name="SignUp"
            component={SignUp}
            options={{ headerShown: false }}
          />
          <Stack.Screen
            name="Home"
            component={HomeScreen}
            options={{ headerShown: false }}
          />
          <Stack.Screen
            name="Inventory"
            component={Inventory}
            options={{ headerShown: false }}
          />
          <Stack.Screen
            name="GraphScreen"
            component={GraphScreen}
            options={{ headerShown: false }}
          />
          <Stack.Screen
            name="Survey1"
            component={Survey1}
            options={{ headerShown: false }}
          />
          <Stack.Screen
            name="Survey2"
            component={Survey2}
            options={{ headerShown: false }}
          />
          <Stack.Screen
            name="Survey3"
            component={Survey3}
            options={{ headerShown: false }}
          />
          <Stack.Screen
            name="Survey4"
            component={Survey4}
            options={{ headerShown: false }}
          />
          <Stack.Screen
            name="CompletionScreen"
            component={CompletionScreen}
            options={{ headerShown: false }}
          />
          <Stack.Screen
            name="MainFriendScreen"
            component={MainFriendScreen}
            options={{ headerShown: false }}
          />
          <Stack.Screen
            name="MailScreen"
            component={MailScreen}
            options={{ headerShown: false }}
          />
          <Stack.Screen
            name="BunnyStatus"
            component={BunnyStatus}
            options={{ headerShown: false }}
          />
          <Stack.Screen
            name="MouseStatus"
            component={MouseStatus}
            options={{ headerShown: false }}
          />
          <Stack.Screen
            name="PigStatus"
            component={PigStatus}
            options={{ headerShown: false }}
          />
          <Stack.Screen
            name="StatusTemplate"
            component={StatusTemplate}
            options={{ headerShown: false }}
          />
          <Stack.Screen
            name="FriendGarden"
            component={FriendGarden}
            options={{ headerShown: false }}
          />
          <Stack.Screen
            name="InviteRequestScreen"
            component={InviteRequestScreen}
            options={{ headerShown: false }}
          />
          <Stack.Screen
            name="VisitRequestScreen"
            component={VisitRequestScreen}
            options={{ headerShown: false }}
          />
          <Stack.Screen
            name="Chat"
            component={Chat}
            options={{ headerShown: false }}
          />
        </Stack.Navigator>
      </NavigationContainer>
    </View>
  );
}

const styles = StyleSheet.create({
  container: {
    flex: 1,
    backgroundColor: Themes.colors.background,
  },
});