import { ImageBackground, StyleSheet, Dimensions } from "react-native";
import { Images, Themes } from "../../../assets/Themes";
import Constants from 'expo-constants';
import React from 'react';
const windowWidth = Dimensions.get('window').width;
const windowHeight = Dimensions.get('window').height;

import CompletionScreenButton from "./CompletionScreenButton";
import CompletionScreenHeader from "./CompletionScreenHeader";

class CompletionScreen extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
    };

    this.nav = this.props.navigation;
    this.params = this.props.route.params;
  }

  render() {
    return (
      <ImageBackground
        style={styles.container}
        source={Images.completionscreen}>
        <CompletionScreenHeader nav={this.nav} setCompleted={this.params.setCompleted} username={this.params.username} />
        <CompletionScreenButton nav={this.nav} setCompleted={this.params.setCompleted} username={this.params.username}/>
      </ImageBackground>
    );
  }
}

const styles = StyleSheet.create({
  container: {
    flex: 1,
    backgroundColor: Themes.colors.background,
    paddingTop: Constants.statusBarHeight,
    alignItems: 'center',
    justifyContent: 'space-between',
  },
})

export default CompletionScreen;