import * as React from 'react';
import { Pressable, StyleSheet, Text, View, Dimensions, PixelRatio } from 'react-native';
import { Themes } from '../../../assets/Themes';
const windowWidth = Dimensions.get('window').width;
const windowHeight = Dimensions.get('window').height;

const onClick = (props) => {
  props.setCompleted(true);
  props.nav.navigate('Inventory', { username: props.username })
}

const CompletionScreenButton = (props) => {
  return (
    <View style={styles.navBox}>
      <View style={Themes.shadows}>
        <Pressable style={styles.button} onPress={() => onClick(props)}>
          <Text style={styles.buttonText}>
            VIEW INVENTORY TO SHOP
          </Text>
        </Pressable>
      </View>
    </View>
  )
}

export default CompletionScreenButton;

const styles = StyleSheet.create({
  navBox: {
    width: windowWidth,
    height: windowHeight * 0.2,
    flexDirection: 'row',
    justifyContent: "center",
    alignContent: "flex-end",
    paddingBottom: windowHeight * 0.325
  },
  buttonText: {
    color: Themes.colors.black,
    fontSize: PixelRatio.getFontScale() * windowHeight * 0.02,
  },
  button: {
    width: windowWidth * 0.8,
    height: windowHeight * 0.07,
    alignItems: 'center',
    justifyContent: "center",
    backgroundColor: Themes.colors.greenButton,
    borderRadius: 10,
    marginHorizontal: 10,
  }
})