import { Pressable, StyleSheet, Text, View, Dimensions, PixelRatio } from "react-native";
import { Images, Themes } from "../../../assets/Themes";
const windowWidth = Dimensions.get("window").width;
const windowHeight = Dimensions.get("window").height;
import React, { useState } from "react";

class ChatSupport extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      
    };
  }

  
  render() {
    return (
      <View style={Themes.shadows}>
        <Pressable
          style={[
            styles.emotionBox,
            {
              backgroundColor: this.state.isActive
                ? Themes.colors.blue
                : Themes.colors.white,
            },
          ]}
          onPress={() => this.handleClick(this.props)}
        >
          <Text style={styles.emotionText}>{this.props.text}</Text>
        </Pressable>
      </View>
    );
  }
}

const styles = StyleSheet.create({
  emotionBox: {
    width: windowWidth * 0.65,
    height: windowHeight * 0.05,
    flexDirection: "row",
    margin: 10,
    alignItems: "center",
    justifyContent: "center",
    backgroundColor: Themes.colors.white,
    borderRadius: 10,
  },
  emotionText: {
    color: Themes.colors.black,
    fontSize: PixelRatio.getFontScale() * windowHeight * 0.024,
    alignItems: "center",
    justifyContent: "center",
  },
});

export default ChatSupport;