import React from 'react';
import { View, Text, Dimensions, StyleSheet, PixelRatio, Image } from "react-native";
import {
    LineChart
} from 'react-native-chart-kit';
import TouchHistoryMath from 'react-native/Libraries/Interaction/TouchHistoryMath';
import { Images, Themes } from "../../../assets/Themes";
const windowWidth = Dimensions.get("window").width;
const windowHeight = Dimensions.get("window").height;
class Graph extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
        }
    }

    mindImage (props) {
        if (props.completed){
            if (props.mind === 0) {
                return (
                    <Image
                    source={Images.mind0}
                    style={styles.img}
                    />
                );
            }
            if (props.mind === 1) {
                return (
                    <Image
                    source={Images.mind1}
                    style={styles.img}
                    />
                );
            }
            if (props.mind === 2) {
                return (
                    <Image
                    source={Images.mind2}
                    style={styles.img}
                    />
                );
            }
            if (props.mind === 3) {
                return (
                    <Image
                    source={Images.mind3}
                    style={styles.img}
                    />
                );
            }
            if (props.mind === 4) {
                return (
                    <Image
                    source={Images.mind4}
                    style={styles.img}
                    />
                );
            }
            if (props.mind === 5) {
                return (
                    <Image
                    source={Images.mind5}
                    style={styles.img}
                    />
                );
            }
        }
        else {
            return (
                <Image
                source={Images.mindPrior}
                style={styles.img}
                />
            );
        }
    }

    bodyImage (props) {
        if (props.completed){
            if (props.body === 0) {
                return (
                    <Image
                    source={Images.body0}
                    style={styles.img}
                    />
                );
            }
            if (props.body === 1) {
                return (
                    <Image
                    source={Images.body1}
                    style={styles.img}
                    />
                );
            }
            if (props.body === 2) {
                return (
                    <Image
                    source={Images.body2}
                    style={styles.img}
                    />
                );
            }
            if (props.body === 3) {
                return (
                    <Image
                    source={Images.body3}
                    style={styles.img}
                    />
                );
            }
            if (props.body === 4) {
                return (
                    <Image
                    source={Images.body4}
                    style={styles.img}
                    />
                );
            }
            if (props.body === 5) {
                return (
                    <Image
                    source={Images.body5}
                    style={styles.img}
                    />
                );
            }
        }
        else {
            return (
                <Image
                source={Images.bodyPrior}
                style={styles.img}
                />
            );
        }
    }
    render() {
        return (
            <View style={styles.container}>
                <View style={styles.img_container}>
                    <Text style={styles.bold}>
                        Last Week's Mental Health
                    </Text>
                    <this.mindImage mind={this.props.mind} completed={this.props.completed}/>
                </View>

                <View style={styles.img_container}>
                    <Text style={styles.bold}>
                        Last Week's Physical Health
                    </Text>
                    <this.bodyImage body={this.props.body} completed={this.props.completed}/>
                </View>
            </View>
        );
    }
}

const styles = StyleSheet.create({
    container: {
        flex: 1,
        backgroundColor: Themes.colors.background,
        alignItems: "center",
        justifyContent: "center"
    },
    bold: {
        textAlign: "center",
        fontSize: PixelRatio.getFontScale() * windowHeight * 0.030,
        fontWeight: "bold",
        color: Themes.colors.darkGreen,
        padding: windowHeight * 0.001
    },
    crops_container: {
        height: windowHeight * 0.65,
        alignItems: "flex-end",
    },
    img: {
        width: windowWidth * 0.85,
        height: windowHeight * 0.25,
    },
    img_container: {
        justifyContent: "center",
        alignContent: "center",
        padding: 15
    }
});

export default Graph;