import { View, StyleSheet, ScrollView, Dimensions } from "react-native";
import { Images, Themes } from "../../../assets/Themes";
import Constants from "expo-constants";
import React, { useState } from "react";
const windowWidth = Dimensions.get("window").width;
const windowHeight = Dimensions.get("window").height;
import Graph from "./Graph";
import PastData from "./PastData";
import GraphHeader from "./GraphHeader";

class GraphScreen extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            surveys: [
                {
                    mind: 4,
                    body: 3,
                    selectedEmotions: ["Stressed, Anxious"],
                    bodyDiscomfort: true,
                    selectedAilments: ["Tired"],
                    completed: true,
                    date: new Date("December 5, 2022")
                },
                {
                    mind: 2,
                    body: 3,
                    selectedEmotions: ["Angry"],
                    bodyDiscomfort: true,
                    selectedAilments: ["Back Aching"],
                    completed: true,
                    date: new Date("December 6, 2022")
                },
                {
                    mind: 0,
                    body: 0,
                    selectedEmotions: [],
                    bodyDiscomfort: false,
                    selectedAilments: [],
                    completed: false,
                    date: new Date("December 7, 2022")
                },
                {
                    mind: 4,
                    body: 4,
                    selectedEmotions: ["Happy", "Relieved"],
                    bodyDiscomfort: false,
                    selectedAilments: ["Cold"],
                    completed: true,
                    date: new Date("December 8, 2022")
                }
            ],
        };

        this.nav = this.props.navigation;
        this.params = this.props.route.params;
    }

    componentDidMount() {
        if (this.params.completed) {
            let surveysArr = [...this.state.surveys];
            surveysArr.push({
                mind: this.params.mind,
                body: this.params.body,
                selectedEmotions: this.params.selectedEmotions,
                bodyDiscomfort: this.params.bodyDiscomfort,
                selectedAilments: this.params.selectedAilments,
                completed: this.params.completed,
                date: new Date()
            });
            this.setState({ surveys: surveysArr });
        }
    }

    componentDidUpdate(prevProps) {
        if (prevProps.route.params.completed !== this.params.completed && this.params.completed) {
            surveysArr = JSON.parse(JSON.stringify(this.state.surveys));
            surveysArr.push({
                mind: this.params.mind,
                body: this.params.body,
                selectedEmotions: this.params.selectedEmotions,
                bodyDiscomfort: this.params.bodyDiscomfort,
                selectedAilments: this.params.selectedAilments,
                completed: this.params.completed,
                date: this.params.date
            });
            this.setState({ surveys: surveysArr }, () => {
                // this.getGraphData();
            });
        }
    }

    // getGraphData() {
    //     let labelsArr = [];
    //     let mindArr = [];
    //     let bodyArr = [];
    //     this.state.surveys.forEach((elem) => {
    //         mindArr.push(elem.mind);
    //         bodyArr.push(elem.body);
    //         const weekday = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
    //         let str_date = weekday[elem.date.getDay()];
    //         labelsArr.push(str_date);
    //     })

    //     this.setState({ mind: mindArr, body: bodyArr, labels: labelsArr });
    // }

    render() {
        return (
            <   View style={styles.container}>
                <GraphHeader nav={this.nav} username={this.params.username} />
                <ScrollView style={styles.container}>
                    <Graph mind={this.params.mind} body={this.params.body} completed={this.params.completed}/>
                    <PastData surveys={this.state.surveys} username={this.params.username} />
                    <View style={{ width: windowWidth, height: windowHeight * 0.20 }}></View>
                </ScrollView>
            </View>
        );
    }
}

const styles = StyleSheet.create({
    container: {
        flex: 1,
        backgroundColor: Themes.colors.background,
        paddingTop: Constants.statusBarHeight,

    },
    scroll_container: {
        flex: 1,
        backgroundColor: Themes.colors.background,
        paddingTop: Constants.statusBarHeight / 2,
        paddingLeft: windowWidth * 0.05
    },
    top_container: {
        flex: 1,
        alignItems: "center",
        justifyContent: "center",
        paddingBottom: windowHeight * 0.5,
    },
    crops_container: {
        height: windowHeight * 0.65,
        alignItems: "flex-end",
    },
});

export default GraphScreen;