import { ImageBackground, StyleSheet, View, Dimensions } from "react-native";
import { Images, Themes } from "../../../assets/Themes";
import Constants from "expo-constants";
import React, { useState } from "react";
import HomeScreenHeader from "./HomeScreenHeader";
const windowWidth = Dimensions.get("window").width;
const windowHeight = Dimensions.get("window").height;
import HomeScreenTopBar from "./HomeScreenTopBar";
import HomeScreenBottomBar from "./HomeScreenBottomBar";

class HomeScreen extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      mind: 0,
      body: 0,
      emotions: ["Stressed", "Anxious", "Angry", "Happy"],
      selectedEmotions: [],
      bodyDiscomfort: false,
      ailments: ["Backache", "Fever", "Nausea", "Seizure"],
      selectedAilments: [],
      completed: false,
      mail: true
    };

    this.navigation = this.props.navigation;
    this.setMind = this.setMind.bind(this);
    this.setBody = this.setBody.bind(this);
    this.setEmotions = this.setEmotions.bind(this);
    this.setSelectedEmotions = this.setSelectedEmotions.bind(this);
    this.setAilments = this.setAilments.bind(this);
    this.setSelectedAilments = this.setSelectedAilments.bind(this);
    this.setBodyDiscomfort = this.setBodyDiscomfort.bind(this);
    this.setCompleted = this.setCompleted.bind(this);
    this.setMail = this.setMail.bind(this);
  }

  setMind(moodNum) {
    this.setState({ mind: moodNum });
  }

  setBody(moodNum) {
    this.setState({ body: moodNum });
  }

  setEmotions(emotions) {
    this.setState({ emotions: emotions });
  }

  setSelectedEmotions(newSelectedEmotions) {
    this.setState({ selectedEmotions: newSelectedEmotions });
  }

  setAilments(ailments) {
    this.setState({ ailments: ailments });
  }

  setSelectedAilments(newSelectedAilments) {
    this.setState({ selectedAilments: newSelectedAilments });
  }

  setBodyDiscomfort(bool) {
    this.setState({ bodyDiscomfort: bool });
  }

  setCompleted(bool) {
    this.setState({ completed: bool });
  }

  setMail(bool) {
    this.setState({ mail: bool })
  }

  render() {
    return (
      <ImageBackground style={styles.container} source={Images.homescreen}>
        <View style={styles.top_container}>
          <HomeScreenHeader username={this.props.route.params.username} />
          <HomeScreenTopBar
            nav={this.navigation}
            mind={this.state.mind}
            setMind={this.setMind}
            body={this.state.body}
            setBody={this.setBody}
            emotions={this.state.emotions}
            setEmotions={this.setEmotions}
            ailments={this.state.ailments}
            setAilments={this.setAilments}
            selectedEmotions={this.state.selectedEmotions}
            setSelectedEmotions={this.setSelectedEmotions}
            selectedAilments={this.state.selectedAilments}
            setSelectedAilments={this.setSelectedAilments}
            bodyDiscomfort={this.state.bodyDiscomfort}
            setBodyDiscomfort={this.setBodyDiscomfort}
            completed={this.state.completed}
            setCompleted={this.setCompleted}
            username={this.props.route.params.username}
            mail={this.state.mail}
            setMail={this.setMail}
          />
        </View>
        <HomeScreenBottomBar nav={this.navigation} username={this.props.route.params.username} />
      </ImageBackground>
    );
  }
}

const styles = StyleSheet.create({
  container: {
    flex: 1,
    backgroundColor: Themes.colors.background,
    paddingTop: Constants.statusBarHeight,
    alignItems: "center",
    justifyContent: "space-between",
  },
  top_container: {
    flex: 1,
    alignItems: "center",
    justifyContent: "center",
    paddingBottom: windowHeight * 0.5,
  },
  crops_container: {
    height: windowHeight * 0.65,
    alignItems: "flex-end",
  },
});

export default HomeScreen;
