import * as React from 'react';
import { Pressable, StyleSheet, Text, View, Dimensions, PixelRatio } from 'react-native';
import { Themes } from '../../../assets/Themes';
const windowWidth = Dimensions.get('window').width;
const windowHeight = Dimensions.get('window').height;


const HomeScreenTopBar = (props) => {
  return (
    <View style={styles.navBox}>
      <View style={Themes.shadows}>
        <Pressable style={styles.invButton} onPress={() => props.nav.navigate('Inventory', { username: props.username })}>
          <Text style={styles.buttonText}>
            GARDEN INVENTORY
          </Text>
        </Pressable>
      </View>
    </View>
  )
}

export default HomeScreenTopBar;

const styles = StyleSheet.create({
  navBox: {
    width: windowWidth,
    height: windowHeight * 0.20,
    flexDirection: 'row',
    justifyContent: "center",
    alignItems: "flex-end",
    padding: 50
  },
  buttonText: {
    color: Themes.colors.black,
    fontSize: PixelRatio.getFontScale() * windowHeight * 0.025,
  },
  invButton: {
    width: windowWidth * 0.70,
    height: windowHeight * 0.07,
    alignItems: 'center',
    justifyContent: "center",
    backgroundColor: Themes.colors.greenButton,
    borderRadius: 10,
    marginHorizontal: 10,
  }
})