import * as React from 'react';
import { StyleSheet, Text, View, Dimensions, PixelRatio } from 'react-native';
import { Themes } from '../../../assets/Themes';
import Constants from 'expo-constants';
const windowWidth = Dimensions.get('window').width;
const windowHeight = Dimensions.get('window').height;

const HomeScreenHeader = (props) => {
  return (
    <View style={styles.greetingBar}>
      <Text style={styles.greetingText}>
        {props.username}'s Garden
      </Text>
    </View>
  );
}

export default HomeScreenHeader;

const styles = StyleSheet.create({
  greetingBar: {
    width: windowWidth,
    height: windowHeight * 0.10,
    paddingTop: Constants.statusBarHeight,
    flexDirection: 'row',
    alignItems: 'flex-start',
    justifyContent: "center",
  },
  greetingText: {
    fontSize: PixelRatio.getFontScale() * windowHeight * 0.048,
    color: Themes.colors.darkBrown,
    alignItems: 'center',
    justifyContent: "space-around",
  }
})