import { Pressable, StyleSheet, Text, View, Dimensions, Image, PixelRatio } from "react-native";
import { Images, Themes } from "../../../assets/Themes";
import Constants from "expo-constants";
import React, { useState } from "react";
import SurveyHeader from "./SurveyHeader";
import Survey1Nav from "./Survey1Nav";
const windowWidth = Dimensions.get("window").width;
const windowHeight = Dimensions.get("window").height;

class Survey1 extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      mind: this.props.route.params.mind,
      body: this.props.route.params.body,
    };
    this.nav = this.props.navigation;
    this.params = this.props.route.params;
  }
  setMindImg = (moodNum) => {
    this.setState({ mind: moodNum }, () => {
      this.params.setMind(moodNum);
    });
  };

  setBodyImg = (moodNum) => {
    this.setState({ body: moodNum }, () => {
      this.params.setBody(moodNum);
    });
  };

  render() {
    console.log(this.state.mind,this.state.body)
    return (
      <View style={styles.container}>
        <View style={styles.surveyScreen}>
          <SurveyHeader nav={this.nav} username={this.params.username} />
          <View style={styles.surveyContent}>
            <View style={styles.surveyContentBox}>
              <View style={styles.surveyQuestionBox}>
                <Text style={styles.surveyQuestion}>How is your mind</Text>
                <Text style={styles.surveyQuestion}>today?</Text>
              </View>
              <View style={styles.moodBox}>
                <View style={Themes.shadows}>
                  <Pressable onPress={() => this.setMindImg(1)}>
                    <Image
                      style={styles.moodImg}
                      source={
                        this.state.mind == 1
                          ? Images.depressedColor
                          : Images.depressedGrey
                      }
                    />
                  </Pressable>
                </View>

                <View style={Themes.shadows}>
                  <Pressable onPress={() => this.setMindImg(2)}>
                    <Image
                      style={styles.moodImg}
                      source={
                        this.state.mind == 2 ? Images.sadColor : Images.sadGrey
                      }
                    />
                  </Pressable>
                </View>

                <View style={Themes.shadows}>
                  <Pressable onPress={() => this.setMindImg(3)}>
                    <Image
                      style={styles.moodImg}
                      source={
                        this.state.mind == 3 ? Images.midColor : Images.midGrey
                      }
                    />
                  </Pressable>
                </View>

                <View style={Themes.shadows}>
                  <Pressable onPress={() => this.setMindImg(4)}>
                    <Image
                      style={styles.moodImg}
                      source={
                        this.state.mind == 4
                          ? Images.goodColor
                          : Images.goodGrey
                      }
                    />
                  </Pressable>
                </View>

                <View style={Themes.shadows}>
                  <Pressable onPress={() => this.setMindImg(5)}>
                    <Image
                      style={styles.moodImg}
                      source={
                        this.state.mind == 5
                          ? Images.greatColor
                          : Images.greatGrey
                      }
                    />
                  </Pressable>
                </View>
              </View>
            </View>
            <View style={styles.surveyContentBox}>
              <View style={styles.surveyQuestionBox}>
                <Text style={styles.surveyQuestion}>How is your body</Text>
                <Text style={styles.surveyQuestion}>today?</Text>
              </View>
              <View style={styles.moodBox}>
                <View style={Themes.shadows}>
                  <Pressable onPress={() => this.setBodyImg(1)}>
                    <Image
                      style={styles.moodImg}
                      source={
                        this.state.body == 1
                          ? Images.depressedColor
                          : Images.depressedGrey
                      }
                    />
                  </Pressable>
                </View>

                <View style={Themes.shadows}>
                  <Pressable onPress={() => this.setBodyImg(2)}>
                    <Image
                      style={styles.moodImg}
                      source={
                        this.state.body == 2 ? Images.sadColor : Images.sadGrey
                      }
                    />
                  </Pressable>
                </View>

                <View style={Themes.shadows}>
                  <Pressable onPress={() => this.setBodyImg(3)}>
                    <Image
                      style={styles.moodImg}
                      source={
                        this.state.body == 3 ? Images.midColor : Images.midGrey
                      }
                    />
                  </Pressable>
                </View>

                <View style={Themes.shadows}>
                  <Pressable onPress={() => this.setBodyImg(4)}>
                    <Image
                      style={styles.moodImg}
                      source={
                        this.state.body == 4
                          ? Images.goodColor
                          : Images.goodGrey
                      }
                    />
                  </Pressable>
                </View>

                <View style={Themes.shadows}>
                  <Pressable onPress={() => this.setBodyImg(5)}>
                    <Image
                      style={styles.moodImg}
                      source={
                        this.state.body == 5
                          ? Images.greatColor
                          : Images.greatGrey
                      }
                    />
                  </Pressable>
                </View>
              </View>
            </View>
          </View>
          <Survey1Nav
            nav={this.nav}
            mind={this.state.mind}
            setMind={this.params.setMind}
            body={this.state.body}
            setBody={this.params.setBody}
            emotions={this.params.emotions}
            setEmotions={this.params.setEmotions}
            ailments={this.params.ailments}
            setAilments={this.params.setAilments}
            selectedEmotions={this.params.selectedEmotions}
            setSelectedEmotions={this.params.setSelectedEmotions}
            selectedAilments={this.params.selectedAilments}
            setSelectedAilments={this.params.setSelectedAilments}
            bodyDiscomfort={this.params.bodyDiscomfort}
            setBodyDiscomfort={this.params.setBodyDiscomfort}
            completed={this.params.completed}
            setCompleted={this.params.setCompleted}
            username={this.params.username}
          />
        </View>
      </View>
    );
  }
}

const styles = StyleSheet.create({
  container: {
    flex: 1,
    backgroundColor: Themes.colors.background,
    flex: 1,
    paddingTop: Constants.statusBarHeight,
    alignItems: "center",
    justifyContent: "center",
  },
  surveyScreen: {
    flex: 1,
    flexDirection: "column",
    alignContent: "flex-start",
  },
  surveyContent: {
    width: windowWidth,
    height: windowHeight * 0.6,
    flexDirection: "column",
    alignItems: "flex-start",
    justifyContent: "flex-start",
  },
  surveyContentBox: {
    width: windowWidth,
    height: windowHeight * 0.3,
    flexDirection: "column",
    alignItems: "flex-start",
  },
  surveyQuestionBox: {
    width: windowWidth,
    height: windowHeight * 0.15,
    flexDirection: "column",
    alignItems: "center",
    justifyContent: "center",
    alignContent: "center",
    margin: 5,
  },
  surveyQuestion: {
    color: Themes.colors.subtext,
    fontWeight: "lighter",
    fontSize: PixelRatio.getFontScale() * windowHeight * 0.037,
  },
  moodBox: {
    width: windowWidth,
    height: windowHeight * 0.15,
    flexDirection: "row",
    flexGrow: 1,
    alignItems: "flex-start",
    justifyContent: "space-around",
    paddingHorizontal: 10,
  },
  moodImg: {
    width: windowWidth * 0.16,
    height: windowWidth * 0.16,
    alignItems: "center",
    justifyContent: "center",
    borderRadius: 99999,
    margin: 5,
  },
});

export default Survey1;
