import React, { useState } from "react";
import { Pressable, StyleSheet, Text, View, Dimensions, PixelRatio } from "react-native";
import { Themes } from "../../../assets/Themes";
const windowWidth = Dimensions.get("window").width;
const windowHeight = Dimensions.get("window").height;

const Survey1Nav = (props) => {
  return (
    <View style={styles.navBox}>
      <View style={Themes.shadows}>
        <Pressable
          style={styles.nextButton}
          onPress={() =>
            props.nav.navigate("Survey2", {
              mind: props.mind,
              setMind: props.setMind,
              body: props.body,
              setBody: props.setBody,
              emotions: props.emotions,
              setEmotions: props.setEmotions,
              selectedEmotions: props.selectedEmotions,
              setSelectedEmotions: props.setSelectedEmotions,
              ailments: props.ailments,
              setAilments: props.setAilments,
              selectedAilments: props.selectedAilments,
              setSelectedAilments: props.setSelectedAilments,
              bodyDiscomfort: props.bodyDiscomfort,
              setBodyDiscomfort: props.setBodyDiscomfort,
              completed: props.completed,
              setCompleted: props.setCompleted,
              username: props.username
            })
          }
        >
          <Text style={styles.buttonText}>NEXT</Text>
        </Pressable>
      </View>
    </View>
  );
};

export default Survey1Nav;

const styles = StyleSheet.create({
  navBox: {
    width: windowWidth,
    height: windowHeight * 0.2,
    flexDirection: "row",
    justifyContent: "center",
    alignItems: "flex-end",
    padding: 50,
  },
  buttonText: {
    color: Themes.colors.black,
    fontSize: PixelRatio.getFontScale() * windowHeight * 0.025,
  },
  nextButton: {
    width: windowWidth * 0.75,
    height: windowHeight * 0.07,
    alignItems: "center",
    justifyContent: "center",
    backgroundColor: Themes.colors.greenButton,
    borderRadius: 10,
    marginHorizontal: 15,
  },
});
