import * as React from 'react';
import { Pressable, StyleSheet, Text, View, Dimensions, Image, PixelRatio } from 'react-native';
import { Images, Themes } from '../../../assets/Themes';
const windowWidth = Dimensions.get('window').width;
const windowHeight = Dimensions.get('window').height;

const SurveyHeader = (props) => {
  return (
    <View>
      <View style={styles.headerbar}>
        <Pressable onPress={() => props.nav.navigate('Home', { username: props.username })}>
          <Image
            style={styles.homeButtonImg}
            source={Images.homeButton}
          />
        </Pressable>
      </View>
      <View style={styles.greetingBar}>
        <Text style={styles.greetingText}>
          Hi {props.username}!
        </Text>
      </View>
    </View>
  );
}

export default SurveyHeader;

const styles = StyleSheet.create({
  surveyScreen: {
    flex: 1,
    flexDirection: 'column',
    alignContent: 'flex-start',
  },
  headerbar: {
    width: windowWidth,
    height: windowHeight * 0.035,
    flexDirection: 'row',
    alignItems: 'flex-start',
    backgroundColor: Themes.colors.background,
  },
  homeButtonImg: {
    width: windowHeight * 0.10 * 0.60,
    height: windowHeight * 0.10 * 0.60,
    justifyContent: 'center',
    alignItems: 'flex-start',
    marginHorizontal: 5
  },
  greetingBar: {
    width: windowWidth,
    height: windowHeight * 0.10,
    flexDirection: 'row',
    alignItems: 'flex-start',
    justifyContent: "center",
  },
  greetingText: {
    fontSize: PixelRatio.getFontScale() * windowHeight * 0.048,
    color: Themes.colors.darkBrown,
    alignItems: 'center',
    justifyContent: "space-around",
  }
})